##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (TextProc)		= PkgName (not the PkgFileName)
# sampledir (ksm-textproc)	= pkg-dirname (under /usr/local/ = ksm-xxx)
# sampleconf (textproc)		= config file name (no path, no extension)
# sampled (sampled)		= the daemon (rc-script, rc-link, script.sh, systemd.service)
# ksm-sample (ksm-sample)	= special name starting with 'ksm-'
# sample (sample)		= all others (xxx, togglexxx)
##############################################################################

# Specfile for TextProc

%define name	ksm-textproc
%define version	1.0.1
%define release	12.0.0
%define _arch	noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _sysddir	/etc/systemd/system
%define _uxbindir	/usr/bin
%define _uxsbindir	/usr/sbin
%define _bindir		/usr/local/bin
%define _sbindir	/usr/local/sbin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	Programs for manipulating textfiles
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Text/Utilities
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	samplepkg,samplecapab
Requires:	coreutils,lynx,mmv,tree,w3m
Requires:	ksm-lib-sh >= 4.1.0-0.0.0
#Provides:	sampled
#Conflicts:	sampled-other,libsample == 0.0.0
#Obsoletes:	mysampled

%description
This package contains following programs for manipulating textfiles:
 ascii2utf, cptree, cpzz, fold-user, getline, html2txt, ksm-cat, ksm-pr, 
 listhex, listraw, replstr, sortinplace, summlines, unfold, utf2ascii, 
 war2txt

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/textproc.conf
#%config %{_confdir}/textproc.conf
#%config %{_scnfdir}/textproc
#%attr(644,root,root)%{_confdir}/textproc.conf
#%attr(644,root,root)%{_scnfdir}/textproc

#%attr(744,root,root)%{_rcdir}/sampled
#%attr(777,root,root)%{_sbindir}/rcsampled
#%attr(744,root,root)%{_sbindir}/sampled.sh

%attr(755,root,root)%{_bindir}/ascii2utf
%attr(755,root,root)%{_bindir}/cptree
%attr(755,root,root)%{_bindir}/cpzz
%attr(755,root,root)%{_bindir}/fold-user
%attr(755,root,root)%{_bindir}/getline
%attr(755,root,root)%{_bindir}/html2txt
%attr(755,root,root)%{_bindir}/ksm-cat
%attr(755,root,root)%{_bindir}/ksm-pr
%attr(755,root,root)%{_bindir}/listhex
%attr(755,root,root)%{_bindir}/listraw
%attr(755,root,root)%{_bindir}/replstr
%attr(755,root,root)%{_bindir}/sortinplace
%attr(755,root,root)%{_bindir}/summlines
%attr(755,root,root)%{_bindir}/unfold
%attr(755,root,root)%{_bindir}/utf2ascii
%attr(755,root,root)%{_bindir}/war2txt

%{_datadir}/RELEASE
%{_datadir}/VERSION
#%attr(744,root,root)%{_datadir}/sampled.rc
#%{_datadir}/sampled.service

#/usr/share/applications/sample.desktop

#%{_icondir}/16x16/apps/sample.png
#%{_icondir}/22x22/apps/sample.png
#%{_icondir}/32x32/apps/sample.png
#%{_icondir}/48x48/apps/sample.png
#%{_icondir}/64x64/apps/sample.png
#%{_icondir}/128x128/apps/sample.png
#/usr/share/pixmaps/sample.png

%docdir %{_man1dir}
%{_man1dir}/ascii2utf.1.gz
%{_man1dir}/cptree.1.gz
%{_man1dir}/cpzz.1.gz
%{_man1dir}/fold-user.1.gz
%{_man1dir}/getline.1.gz
%{_man1dir}/html2txt.1.gz
%{_man1dir}/ksm-cat.1.gz
%{_man1dir}/ksm-pr.1.gz
%{_man1dir}/listhex.1.gz
%{_man1dir}/listraw.1.gz
%{_man1dir}/replstr.1.gz
%{_man1dir}/sortinplace.1.gz
%{_man1dir}/summlines.1.gz
%{_man1dir}/unfold.1.gz
%{_man1dir}/utf2ascii.1.gz
%{_man1dir}/war2txt.1.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
#%{_docdir}/README.de

#---------------------- ORDER OF SCRIPTLETS ----------------------------------
# O=old pkg, N=new pkg

# INSTALL:
# 1. Run %pre section of N		(Arg is 1)
# 2. Install files from N
# 3. Run %post section of N		(Arg is 1)

# UNINSTALL:
# 1. Run %preun section of O		(Arg is 0)
# 2. Delete files from O
# 3. Run %postun section of O		(Arg is 0)

# UPGRADE:
#  1. Run %pre section of O		(Arg is 2)
#  2. Install files from N
#  3. Run %post section of N		(Arg is 2)
#  4. Execute install. triggers (%triggerin in other pkgs) set off by install N
#  5. Execute installation triggers of N
#  6. Execute uninstallation triggers (%triggerun) of O
#  7. Execute uninstallation triggers (of other pkgs) set off by uninstall O
#  8. Run %preun section of O		(Arg is 1)
#  9. Delete files from O not contained in N
# 10. Run %postun section of O		(Arg is 1)

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# create group and user
#ngroup='' nuser='' npwd='' ncomm='' nhomedir='' nlogsh='' ngid=0 nuid=0 ret=0

# backup config files
#test -e %{_confdir}/textproc.conf && cp %{_confdir}/textproc.conf %{_confdir}/textproc.conf.rpmsave
#test -e %{_scnfdir}/textproc && cp %{_scnfdir}/textproc %{_scnfdir}/textproc.rpmsave

# disable sample daemon and stop sampledm
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
#test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
#rm -f %{_libdir}/libfuncstd-sh

# uninstall desktop files
#xdg-desktop-menu uninstall \
#	/usr/share/applications/sample.directory \
#	/usr/share/applications/sample.desktop \
#	/usr/share/applications/sample-admin.desktop

# INIT SCRIPT/SYSTEMD UNIT - uninstall TextProc
#if [ -d %{_sysddir} ]; then				# systemd
#	if [ -e %{_sysddir}/sampledm.service ]; then
#		systemctl stop sampledm.service
#		systemctl disable sampledm.service
#		rm %{_sysddir}/sampledm.service
#		systemctl daemon-reload
#	fi
#else							# SysV init
#	if [ -e %{_rcdir}/sampledm ]; then
#		test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop > /dev/null 2>&1
#		insserv -r sampledm > /dev/null 2>&1
#		rm -f %{_rcdir}/sampledm
#		rm -f %{_sbindir}/rcsampledm
#	fi
#fi

#if [ "$1" == 1 ]; then					# install package
#	# create group and user
#	ngroup=nobody					# new group account
#	ngid=65533					# new GID
#	nuser=nobody					# new user account
#	nuid=65534					# new UID
#	npwd=nobody					# password for new usr
#	ncomm="nobody"					# comment for new usr
#	nhomedir=/var/lib/$nuser			# home dir for new usr
#	nlogsh=/bin/bash			# login shell for new user
#	grep -m 1 "^$ngroup:" /etc/group > /dev/null 2>&1
#	ret=$?
#	if [ "$ret" -eq 1 ]; then			# group not found
#		groupadd --preferred-gid $ngid $ngroup
#	fi
#	grep -m 1 "^$nuser:" /etc/passwd > /dev/null 2>&1
#	ret=$?
#	if [ "$ret" -eq 1 ]; then			# user not found
#		useradd -c "$ncomm" -d $nhomedir -g $ngroup -m -p $npwd --preferred-uid $nuid -s $nlogsh $nuser
#	fi
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# Definition of vars
# set config pathname. config file needs a version at first cnfvar!
#cf=%{_confdir}/textproc.conf
#cnfvars=$(grep -v '^#' $cf | grep '[[:alnum:]]' | grep -v '\[' | cut -sd '=' -f1)
#cnfvars=$(echo $cnfvars | cut -d ' ' -f2-)
#ret=0
#
#incf=%{_confdir}/textproc.incl

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

# enable sample daemon
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -e -q > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog
#ln -sf %{_libdir}/libfuncstd-sh-%{version} %{_libdir}/libfuncstd-sh

# handle include files
#if [ -e "$incf" ]; then
#	rm $incf.rpmnew
#else
#	mv $incf.rpmnew $incf
#	echo "Check $incf"
#fi

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/sample.directory \
#	/usr/share/applications/sample.desktop \
#	/usr/share/applications/sample-admin.desktop

# add a (new) template to sample
#f=/.../sample						# pathname of file
#templ=%{_datadir}/sample.add				# template in datadir
#tmpf=/tmp/sample					# tempfile
#flag=ksm-textproc						# flag for entries
#if [ -e $f ]; then					# file exist
#	grep -q $flag $f				# look for flag
#	ret=$?
#	if [ $ret -ne 0 ]; then				# no flag found
#		cat $templ >> $f			# add entries
#	else						# flag found
#		cat $f | grep $flag > $tmpf		# get add from file
#		cmp -s $tmpf $templ			# cmp add vs. templ
#		ret=$?
#		if [ $ret -ne 0 ]; then			# templ is new
#			cat $f | grep -v $flag > $tmpf	# rm add from file
#			cp $tmpf $f
#			cat $templ >> $f		# add new entries
#		fi
#		rm -f $tmpf
#	fi
#else
#	echo "File $f not found!"
#fi

# INIT SCRIPT/SYSTEMD UNIT - install TextProc
#if [ -d %{_sysddir} ]; then				# systemd
#	cp --preserve=mode %{_datadir}/sampledm.service %{_sysddir}/
#	systemctl daemon-reload
#	systemctl enable sampledm.service
#	echo "sampledm is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start sampledm within yast or manual with:"
#	echo "systemctl start sampledm.service"
#else							# SysV init
#	cp --preserve=mode %{_datadir}/sampledm.rc %{_rcdir}/sampledm
#	ln -sf %{_rcdir}/sampledm %{_sbindir}/rcsampledm
#	insserv sampledm > /dev/null 2>&1
#	echo "sampledm is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start sampledm within yast or manual with rcsampledm start"
#fi

# install/update all users rc files
#updcmd='' usr='' u=''
#updcmd="%{_bindir}/update-sample -q"
# for all usr below /home/ do:
#usr=$(/usr/bin/grep /home/ /etc/passwd | /usr/bin/cut -d : -f 1)
#for u in $usr; do
#	/bin/su $u -c "$updcmd"
#done

#if [ "$1" == 1 ]; then					# install package
#	echo "Configure $cf"
#else							# upgrade package
#	# update global conf
#	if [ -e $cf.rpmsave ]; then
#		c='' s='' t=''
#		#cp $cf $cf.rpmnew
#		. $cf
#		. $cf.rpmsave
#
#		# update conf vars START -------------------------------------
#		if [ -x %{_bindir}/replcnfvar ]; then
#			for c in $cnfvars; do
#				t="\$$c"
#				eval s="$t"
#				s=\"$s\"
#				%{_bindir}/replcnfvar $cf $c "$s"
#			done
#		else
#			echo "Error - cmd replcnfvar not found or not executable!" >&2
#			echo "Conf file not updated!" >&2
#		fi
#		# update conf vars STOP --------------------------------------
#
#		# update array vars START ------------------------------------
#		cnt=0 i=0
#		# array var MainArr (contignous index from 0)
#		cnt=${#MainArr[@]}			# max members of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any member in use?
#			while [ "$i" -lt $cnt ]; do
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#				let ++i
#			done
#		fi
#
#		# array var MainArr (contignous index from 1)
#		cnt=${#MainArr[@]}			# max members of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any member in use?
#			while [ "$i" -lt $cnt ]; do
#				let ++i
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi
#		# update array vars STOP -------------------------------------
#
#		# compare new conf vars <--> old conf vars
#		diff $cf $cf.rpmsave > /dev/null 2>&1
#		ret=$?
#		if [ "$ret" -eq 0 ]; then
#			rm $cf.rpmsave
#		else
#			echo "Check $cf"
#		fi
#	fi
#fi
# if libraries contained:
#ldconfig
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

#if [ "$1" == 0 ]; then					# remove package
	# backup config files
	#test -e %{_confdir}/textproc.conf && cp %{_confdir}/textproc.conf %{_confdir}/textproc.conf.rpmsave
	#test -e %{_scnfdir}/textproc && cp %{_scnfdir}/textproc %{_scnfdir}/textproc.rpmsave

	# disable sample daemon and stop sampledm
	#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	#rm -f %{_libdir}/libfuncstd-sh

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/sample.directory \
	#	/usr/share/applications/sample.desktop \
	#	/usr/share/applications/sample-admin.desktop

	# remove entries from file sample
	#f=/.../sample					# pathname of file
	#tmpf=/tmp/sample				# tempfile
	#flag=ksm-textproc					# flag for entries
	#ret=0
	#if [ -e $f ]; then
	#	grep -q $flag $f			# look for flag
	#	ret=$?
	#	if [ $ret -eq 0 ]; then			# flag found
	#		cat $f | grep -v $flag > $tmpf	# rm add from file
	#		cp $tmpf $f
	#		rm -f $tmpf
	#	fi
	#else
	#	echo "File $f not found!"
	#fi

	# INIT SCRIPT/SYSTEMD UNIT - uninstall TextProc
	#if [ -d %{_sysddir} ]; then				# systemd
	#	if [ -e %{_sysddir}/sampledm.service ]; then
	#		systemctl stop sampledm.service
	#		systemctl disable sampledm.service
	#		rm %{_sysddir}/sampledm.service
	#		systemctl daemon-reload
	#	fi
	#else							# SysV init
	#		test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop > /dev/null 2>&1
	#		insserv -r sampledm > /dev/null 2>&1
	#		rm -f %{_rcdir}/sampledm
	#		rm -f %{_sbindir}/rcsampledm
	#	fi
	#fi
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/ksm-textproc
#else							# upgrade package
fi
exit 0

%changelog
* Tue Aug 01 2023 Repomaster <repomaster@kaesmann-online.de> 1.0.1-12.0.0
- Added 'fold-user' and 'unfold' from package Local-JK.

* Fri Feb 03 2023 Repomaster <repomaster@kaesmann-online.de> 1.0.1-11.0.0
- 'ascii2utf' and 'utf2ascii' have been revised/improved.

* Wed Apr 06 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.1-10.0.1
- The docu in 'cptree' has been revised/improved.

* Fri Feb 18 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.1-10.0.0
- Added cptree.

* Thu Jan 06 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.1-9.0.0
- Update to the libfuncstd-sh 4.0.0

* Mon May 04 2020 Repomaster <repomaster@kaesmann-online.de> 1.0.1-8.1.0
- ksm-cat and ksm-pr have been revised/improved.

* Sun Mar 29 2020 Repomaster <repomaster@kaesmann-online.de> 1.0.1-8.0.0
- Added ksm-cat.

* Wed Mar 25 2020 Repomaster <repomaster@kaesmann-online.de> 1.0.1-7.1.0
- ksm-pr has been modified
  (added option --fold).

* Sat Mar 07 2020 Repomaster <repomaster@kaesmann-online.de> 1.0.1-7.0.0
- Added ksm-pr. Moved from package ksm-utils.

* Fri Feb 24 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.1-6.5.0
- The script sortinplace has been revised.

* Tue Feb 07 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.1-6.4.0
- All scripts have been revised
  (using function GetOpt).

* Fri Jan 13 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.1-6.3.0
- Deleted following scripts:
  latin2utf8, list-utfger2ascii
- Added the script ascii2utf.
- All scripts have been revised.

* Mon Nov 07 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.1-6.2.0
- The script summlines has been revised.

* Thu Oct 16 2014 Repomaster <repomaster@kaesmann-online.de> 1.0.1-6.1.0
- The script cpzz has been revised
  (syntax error in line 289).

* Fri Sep 26 2014 Repomaster <repomaster@kaesmann-online.de> 1.0.1-6.0.0
- The script cp-zz has been renamed to cpzz.
- The docu has been revised.

* Sun Jun 09 2013 Juergen Kaesmann <juergen@kaesmann.us> 1.0.1-5.2.0
- Dem Script sortinplace wurde die option -k hinzugefuegt.

* Wed Sep 26 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-5.1.0
- The package has been revised.

* Tue Apr 03 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-5.0.0
- The release naming scheme has changed ('.ksm' is removed).

* Sun Nov 13 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-5.0.0.ksm
- Following script has moved to package ksm-root-admin: makemanpage.
- Following scripts has moved to package ksm-utils:
  beautf-fn, beautf-up1, beep, lowerchar-fn, maketar, mvl,
  renumfiles, untar.
- The script resortchlog is deleted.

* Sun Feb 13 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-4.0.0.ksm
- Added the script beautf-up1.

* Wed Jan 26 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-3.0.0.ksm
- Added the script lowerchar-fn.

* Tue Jan 04 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-2.2.0.ksm
- The package name has changed to avoid conflicts with the openSUSE
  distribution. It has been prepended with 'ksm-'.

* Mon Jan 03 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-2.2.0.ksm
- Added cmd -a to maketar.

* Thu Feb 25 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-2.1.0.ksm
- All scripts are revised.
- Script untar is corrected (Now wildcards are funktional).

* Tue Feb 02 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-2.0.2.ksm
- Read version and dependency infos from external files.

* Wed Jan 27 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-2.0.1.ksm
- The docu has changed.

* Wed Jan 27 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-2.0.0.ksm
- Script replcnfvar is moved to package Lib-SH.

* Tue Jan 26 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-1.0.0.ksm
- Added script resortchlog.
- The docu is revised.

* Thu Jan 14 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.0.1.ksm
- Some man pages are improved.

* Fri Nov 13 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.ksm.0.0
- The program lr has moved from package Utils to package textproc.
  Following program names are changed:
  lc --> list-utfger2ascii
  lh --> listhex
  lr --> listraw

* Mon Oct 26 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.0
- The package management has changed to RPM.
